<?php
namespace Teknisa\FIS\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Fiscal\Entities\Paramfiscal;
use Teknisa\Model\Geral\Entities\Paramgeral;

class Fis01500ParametrosDeFiscalFactory {

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function getParamFiscal(){
        $params = array();
        $paramfiscal = $this->entityManager->getRepository(Paramfiscal::class)->findOneBy($params);
        return $paramfiscal;
    }

     public function getParamGeral(){
        $params = array();
        $paramgeral = $this->entityManager->getRepository(Paramgeral::class)->findOneBy($params);
        return $paramgeral;
    }
    
    public function insertParamFiscal($row) {
        
    	$sql = "INSERT INTO PARAMFISCAL
                (IDGERDECMPBLOQ, IDREPPARAMFOS, IDCONSINSESTA, DTININFFORPER, 
                 IDNFFORAPERAPU, IDBLOQNFPENDE, IDBLOQNFSEMINCID,IDREAPREVALAUT, IDCONTCTBL)
               VALUES
               (:P_IDGERDECMPBLOQ,   :P_IDREPPARAMFOS, :P_IDCONSINSESTA, :P_DTININFFORPER, 
                :P_IDNFFORAPERAPU,   :P_IDBLOQNFPENDE, :P_IDBLOQNFSEMINCID, :P_IDREAPREVALAUT, :P_IDCONTCTBL)";
              
              
        $params = array("P_IDGERDECMPBLOQ"		=> $row['IDGERDECMPBLOQ'],
						"P_IDREPPARAMFOS"		=> $row['IDREPPARAMFOS'], 
						"P_IDCONSINSESTA"		=> $row['IDCONSINSESTA'],
						"P_DTININFFORPER"		=> date("d/m/Y", strtotime($row['DTININFFORPER'])),
						"P_IDNFFORAPERAPU"		=> $row['IDNFFORAPERAPU'],
						"P_IDBLOQNFPENDE"	    => $row['IDBLOQNFPENDE'],
						"P_IDBLOQNFSEMINCID"	=> $row['IDBLOQNFSEMINCID'],
						"P_IDREAPREVALAUT"	    => $row['IDREAPREVALAUT'],
						"P_IDCONTCTBL"	        => $row['IDCONTCTBL']);
						
		$std = $this->entityManager->getConnection()->prepare($sql);
        return $std->execute($params);
    }
    
}