<?php
namespace Teknisa\FIS\Services;

use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Teknisa\Libs\Util\DateUtil;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\FIS\Factories\Fis01500ParametrosDeFiscalFactory;

class Fis01500ParametrosDeFiscalService{

	protected $environment;
	protected $dataSourceManager;

	public function __construct(EntityManager $entityManager, Environment $environment, Fis01500ParametrosDeFiscalFactory $fis01500ParametrosDeFiscalFactory){
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->fis01500ParametrosDeFiscalFactory = $fis01500ParametrosDeFiscalFactory;
	}

	public function salvarParametrosDeFiscal($row){
	    $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
	    try{
	    	$paramFiscal = $this->fis01500ParametrosDeFiscalFactory->getParamFiscal($row);
	        if(is_null($paramFiscal)){
	        	$this->fis01500ParametrosDeFiscalFactory->insertParamFiscal($row);
	        }else{
		        $paramFiscal->setIdgerdecmpbloq($row['IDGERDECMPBLOQ']);
		        $paramFiscal->setIdrepparamfos($row['IDREPPARAMFOS']);
		        $paramFiscal->setIdconsinsesta($row['IDCONSINSESTA']);
		        $paramFiscal->setDtininfforper($this->formataData($row['DTININFFORPER']));
		        $paramFiscal->setIdnfforaperapu($row['IDNFFORAPERAPU']);
		        $paramFiscal->setIdbloqnfpende($row['IDBLOQNFPENDE']);
		        $paramFiscal->setIdbloqnfsemincid($row['IDBLOQNFSEMINCID']);
		        $paramFiscal->setIdreaprevalaut($row['IDREAPREVALAUT']);
		        $paramFiscal->setIdcontctbl($row['IDCONTCTBL']);
		        $this->entityManager->persist($paramFiscal);
	    	}
	        $paramGeral = $this->fis01500ParametrosDeFiscalFactory->getParamGeral($row);
	        $paramGeral->setCdpictcfis($row['CDPICTCFIS']);
	        $this->entityManager->persist($paramGeral);
	        $this->entityManager->flush();
	        $connection->commit();
	    }catch(\Exception $e){
	        $this->entityManager->rollBack();
	        throw $e;
	    }
	}
	
	public function formataData($data)
    {
        if (strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDatadeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }
}